create user proxyuser identified by proxypassword default tablespace SYSTEM;
create user adam identified by west default tablespace SYSTEM;
create user bill identified by clinton default tablespace SYSTEM;
create user charlie identified by brown default tablespace SYSTEM;
create user vpdAdmin identified by vpdAdmin default tablespace SYSTEM;

grant create session to proxyuser;
grant create session to adam;
grant create session to bill;
grant create session to charlie;
grant create session to vpdAdmin;
create table System.Accounts (Username varchar2(20), Balance float) tablespace SYSTEM;
			
grant select, update on System.Accounts to proxyuser;
grant select on System.Accounts to adam;
grant select on System.Accounts to bill;
grant select on System.Accounts to charlie;
grant update on System.Accounts to vpdAdmin;
			
insert into System.Accounts (Username, Balance) values ('adam', 100.0);
insert into System.Accounts (Username, Balance) values ('bill', 2000.0);
insert into System.Accounts (Username, Balance) values ('charlie', 30.0);
			
alter user adam grant connect through proxyuser;
alter user bill grant connect through proxyuser;
alter user charlie grant connect through proxyuser;
alter user vpdAdmin grant connect through proxyuser;

create or replace function
  accounts_access_policy
  (obj_schema varchar2, obj_name varchar2) return varchar2
  
  is
  
  d_predicate varchar2(2000);
  v_user varchar2(20);
  
  begin
  
  v_user:=lower(sys_context('userenv', 'session_user'));
  if v_user != 'proxyuser' then
    null;
  else
    /*v_user:=lower(sys_context('userenv', 'proxy_user'));*/
    /*v_user:='adam';*/
  end if;
  
  d_predicate:= 'lower(Username) = '''||v_user||'''';
  /* d_predicate := 'Balance = 30.0'; */
  
  return d_predicate;
  
  end;
 
begin
DBMS_RLS.ADD_POLICY (
  'system',
  'accounts',
  'access_policy',
  'system',
  'accounts_access_policy',
  'select'
);
end;
