/*
* JBoss, Home of Professional Open Source
* Copyright 2007, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package sample.vpd.ejb;

import javax.ejb.Remote;

/**
 * The remote interface to the Bank EJB3 Enity Bean.
 * 
 * @author <a href="pbennett@redhat.com">Pete Bennett</a>
 * @version $Revision: 1.1 $
 * @see sample.vpd.ejb.Bank
 */
@Remote
public interface BankRemote
{
   /**
    * Queries a named bank account for its current balance.
    * 
    * @param accountName the name of the owner of the account
    * @return the current balance for the named account
    */
   Double getBalance(String accountName);
   
   /**
    * Changes the balance for a named bank account.
    * 
    * @param accountName the name of the owner of the account
    * @param balance the new balance for the account
    */
   void setBalance(String accountName, Double balance);
}
